subroutine local Hessianmaker(group latent1, group latent2, coef bb, coef cc, coef rho, matrix H)
	%latent1 = latent1.@members
	%latent2 = latent2.@members

	%dep1 = @word(%latent1,1)
	%dep2 = @word(%latent2,1)
	vector dep1 = @convert({%dep1})
	vector dep2 = @convert({%dep2})
	%var1 = @wmid(%latent1,2)
	%var2 = @wmid(%latent2,2)
	%gvar1=@getnextname("_g1")
	%gvar2=@getnextname("_g2")
	group {%gvar1} {%var1}
	group {%gvar2} {%var2}
	matrix vars1 = @convert({%gvar1})
	matrix vars2 = @convert({%gvar2})
	!pi = @acos(-1) 
	vector x1b = vars1*bb
	vector x2b = vars2*cc
	vector s1 = (2*dep1-1)
	vector s2 = (2*dep2-1)
	vector s12 = @emult(s1,s2)	
	vector g1s = @emult(x1b,s1)
	vector g2s = @emult(x2b,s2)
	vector g12s = @emult(g1s,g2s)
	
	!kappa = rho(1)
	rho = @atan(!kappa)*2/@acos(-1)
	vector rhos = rho(1)*s12
	vector rhos1 = @ones(@obs(rhos),1)-@emult(rhos,rhos)
	vector del = @ediv(@ones(@obs(rhos),1),@sqrt(rhos1))
	vector v1 = @emult(del,(g2s - @emult(rhos,g1s)))
	vector v2 = @emult(del,(g1s - @emult(rhos,g2s)))
	vector g1i = @emult(@dnorm(g1s),@cnorm(v1))
	vector g2i = @emult(@dnorm(g2s),@cnorm(v2))
	vector b = @cbvnorm(g1s,g2s,rhos)
	vector temp1 = -0.5*@ediv( (@emult(g1s,g1s)+@emult(g2s,g2s)-2*@emult(rhos,g12s)) , rhos1) 
	vector temp2 = @ediv(@ones(@obs(rhos),1),(2*!pi*@sqrt(rhos1)))
	vector phi2 = @emult(temp2,@exp(temp1))
	
	'------------------------------------
	vector factor11 = @ediv(@emult(g1s,g1i) + @emult(rhos,phi2) + @ediv(@emult(g1i,g1i),b),b)
	vector factor12 = @emult(@ediv(s12,b),(@emult(g1i,@ediv(g2i,b))-phi2))
	vector factor13 = @emult(@emult(s2,@ediv(phi2,b)),(@emult(-rhos,@emult(del,v1))+g1s+@ediv(g1i,b)))
	vector factor22 = @ediv(@emult(g2s,g2i) + @emult(rhos,phi2) + @ediv(@emult(g2i,g2i),b), b)
	vector factor23 = @emult(@ediv(@emult(s1,phi2),b),(@emult(-rhos,@emult(del,v2))+g2s+@ediv(g2i,b)))
	vector wRw = -1+@emult(@emult(del,del),(@emult(g1s,g1s)+@emult(g2s,g2s)-2*@emult(rhos,@emult(g1s,g2s))))
	vector factor33 = @emult(@ediv(phi2,b),@emult(@emult(@emult(del,del),rhos),wRw)-@emult(@emult(del,del),@emult(g1s,g2s))+@ediv(phi2,b))
		
	matrix(@wcount(%latent1)-1,@wcount(%latent1)-1) H11
	'DB1DB1
	for !i=1 to @wcount(%latent1)-1
		vector tempvar1 = @columnextract(vars1, !i)
		for !j=1 to @wcount(%latent1)-1			
			vector tempvar2 = @columnextract(vars1, !j)
			H11(!i,!j) = @sum( @emult(@emult(tempvar1,tempvar2),factor11) )
		next
	next
	
	matrix(@wcount(%latent1)-1,@wcount(%latent2)-1) H12
	'DB1DB2
	for !i=1 to @wcount(%latent1)-1
		vector tempvar3 = @columnextract(vars1, !i)
		for !j=1 to @wcount(%latent2)-1			
			vector tempvar4 = @columnextract(vars2, !j)
			H12(!i,!j) = @sum( @emult(@emult(tempvar3,tempvar4),factor12) )
		next
	next
	matrix H21 = @transpose(H12)
	
	matrix(@wcount(%latent1)-1,1) H13
	'DB1Drho
	for !i=1 to @wcount(%latent1)-1
		vector tempvar5 = @columnextract(vars1, !i)
		H13(!i,1) = @sum( @emult(tempvar5,factor13) )
	next
	matrix H31 = @transpose(H13)
	
	matrix(@wcount(%latent2)-1,@wcount(%latent2)-1) H22
	'DB2DB2
	for !i=1 to @wcount(%latent2)-1
		vector tempvar6 = @columnextract(vars2, !i)
		for !j=1 to @wcount(%latent2)-1			
			vector tempvar7 = @columnextract(vars2, !j)
			H22(!i,!j) = @sum( @emult(@emult(tempvar6,tempvar7),factor22) )
		next
	next
	
	matrix(@wcount(%latent2)-1,1) H23
	'DB2Drho
	for !i=1 to @wcount(%latent2)-1
		vector tempvar8 = @columnextract(vars2, !i)
		H23(!i,1) = @sum(@emult(tempvar8,factor23))
	next
	matrix H32 = @transpose(H23)
	
	'DrhoDrho
	matrix H33 = @sum(factor33)
	
	'-------------------------------------------------------
	!len1 = @wcount(%var1)
	!len2 = @wcount(%var2)
	!total=!len1+!len2+1
	matrix(!total,!total) invH
	matplace(invH,H11,1,1)
	matplace(invH,H12,1,!len1+1)
	matplace(invH,H13,1,!len1+!len2+1)
	matplace(invH,H21,!len1+1,1)
	matplace(invH,H22,!len1+1,!len1+1)
	matplace(invH,H23,!len1+1,!len1+!len2+1)
	matplace(invH,H31,!len1+!len2+1,1)
	matplace(invH,H32,!total,!len1+1)
	matplace(invH,H33,!total,!total)
	matrix H = @inverse(invH)
	vector SE = @sqrt(@getmaindiagonal(H))
	if @lasterrnum>1 then
		@uiprompt("Due to nonpostive diagonals in Hessian, possibly problematic SEs, try EViews-supplied covariance matrix")
	endif
endsub
